
const BOULES_WEIGHT_VERSION = 1.0;

outlets = 2;
inlets = 2;

// var boules_num = 8;
// var sources_num = 8;
// 
// var boules_num = jsarguments[1];
// var sources_num = jsarguments[2];

var boules_array = new Array();
var sources_array = new Array();


var x=0.,y=0.,z=0.;
const min_dist = 0.02;
const min_value = 0.01;


var src_num = 1;

var outlist = new Array();
var outmatrix = new Array(src_num-1,0,0.);

//**********************
// BOULES
//**********************


function boule_o(num,x,y,sizex,sizey,shape)
{
	this.num = num;
	this.x = x;
	this.y = y;
	
	this.sizex = sizex;
	this.sizey = sizey;
	this.shape = shape;
}

function source_o(num,x,y)
{
	this.num = num;
	this.x = x;
	this.y = y;
}

function clear_boules()
{
	for(var i = 0; i < boules_array.length;i++)
	{
			outmatrix[1] = i;
			outmatrix[2] = 0.;
			outlet(0,outmatrix);
	}
	
	boules_array.length = 0;
}


function boule(num,x,y,sizex,sizey,shape)
{
	
	if( num > 0 )
		boules_array[num-1] = new boule_o(num,x,y,sizex,sizey,shape);
	else
		clear_boules();
}

function source(num,x,y,z)
{
	if ( num > 0)
	{
		outlist.length = 0;
	
		var value;
		var dist,x2,y2;
			
		
		outlist.push(num);
		
		
			for(var i = 0; i < boules_array.length;i++)
			{
				if(boules_array[i])
				{
					x2 = (x - boules_array[i].x)/boules_array[i].sizex;
					y2 = (y - boules_array[i].y)/boules_array[i].sizey;
					dist = x2*x2 + y2*y2;
					
					if(dist>1)value = 0.;
					else
					switch(boules_array[i].shape)
					{
						case 1 : // Gaussian
							value = Math.exp(-5*dist);
							break;
							
						case 2 : // Linear
							
							value = 1 - dist;
							break;
							
						case 3 : // Exponential
							value = 1-Math.sqrt(Math.sqrt(dist));
	
							break;
						
						case 4 : // Exponential 2
							dist = Math.max(Math.sqrt(dist),min_dist);
							value = min_dist*min_dist/(2. *dist*min_value);
							break;
						
						case 5 : // Threshold
							value = 1.;
							break;
						
							
					}
				}else value = 0.;
				outmatrix[0] =  num - 1;
				outmatrix[1] = i;
				outmatrix[2] = value;
				outlet(0,outmatrix);
				outlist.push(value);
			}
		
		outlet(1,outlist);
	}
}

function list(l)
{
	
	//post(arguments.length+"   "+ inlet+"   boules num "+ boules_array.length);
	//post();
	outlist.length = 0;
	
	var value;
	var dist,x2,y2;
	
	if (arguments.length >= 2)
	{
		x = arguments[0];
		y = arguments[1];
		if (arguments.length > 2)
		z = arguments[3];
	}
		
	
	
	if( 1)
	{
		for(var i = 0; i < boules_array.length;i++)
		{
			x2 = (x - boules_array[i].x)/boules_array[i].sizex;
			y2 = (y - boules_array[i].y)/boules_array[i].sizey;
			dist = x2*x2 + y2*y2;
			
			if(dist>1)value = 0.;
			else
			switch(boules_array[i].shape)
			{
				case 1 : //
					value = Math.exp(-5*dist);
					break;
					
				case 2 : // 1/x
					dist = Math.max(Math.sqrt(dist),min_dist);
					value = min_dist*min_dist/(2. *dist*min_value);
					break;
					
				
					
			}
			outmatrix[1] = i;
			outmatrix[2] = value;
			outlet(0,outmatrix);
			outlist.push(value);
		}
	}
	outlet(1,outlist);
	
}